program example;

{$APPTYPE CONSOLE}

uses
  cgilib in 'cgilib.pas', windows,
  sysutils;


var CGI: TCGI;             // CGI global variable


// ***********************************************************
// This function will return rows from emp table
// ***********************************************************
procedure Exec;
var TempCookie: boolean;
    CookieValue: string;
    TempCookieValue: integer;
begin
  // First, let's check do we have cookie
  TempCookie := CGI.GetCookie('DINX', CookieValue);

  // Increment cookie value by one
  TempCookieValue := StrToIntDef(CookieValue, 0);
  Inc(TempCookieValue);

  // Form cookie string
  CGI.ResetCookieString;
  // Set permanent cookie which will last 5 seconds and it
  // will be valid for whole site - check Path parameter
  // If path is empty string then this cookie is valid
  // only for this script
  CGI.AddCookie('DINX', IntToStr(TempCookieValue), Now + EncodeTime(0, 0, 5, 0), '/', '', false);
  CGI.AddCookie('ASDINX', IntToStr(TempCookieValue + 1), Now + EncodeTime(0, 0, 5, 0), '/', '', false);

  // This is example how to set session cookie
  //  CGI.AddCookie('DINX', IntToStr(TempCookieValue), 0, '/', '', false);

  // return HTTP header - inside header is cookie
  // if you put 0 as second parameter then page will never expire
  // if you want page to expire immediately after loaded then
  // put some old date (for example 2 is good old date)
  // in this exemple page will expire immediately after loaded
  CGI.ReturnHeader('text/html', 2);

  // return some body text
  Writeln('<BODY bgcolor="navy" style="color: yellow">');
  Writeln('<center><h1>CGI test program for Delphi - CGILib ' + CGILIB_VERSION + '</h1>');
  Writeln('<br>');
  if TempCookie then begin
    Writeln('<br>This is your, at least, second visit to this page in last 5 seconds.')
  end
  else begin
    Writeln('<br>This is your first visit to this page in last 5 seconds.');
    Writeln('<br>Now, cookie is set which will be deleted by browser after 5 seconds.');
    Writeln('<br>Try refresh button again and check cookie counter.');
  end;
  Writeln('<br><b>Extracted value for cookie DINX: ', CookieValue, '</b>');
  Writeln('<br>All cookies and cookie values: ', CGI.HTTP_COOKIE);
  Writeln('</center>');

  Writeln('<hr>');
    Writeln('<a href="/cgi-bin/Example.exe/GetInputForm"><b style="color: yellow">Test input form</b></a>');
  Writeln('<hr>');

  Writeln('<br><h2 style="color: lightgreen">This is listing of some functions inside TCGI class</h2>');
  Writeln('<b>');

    Writeln('<br><b> These functions return true if VariableName is found</b>');
    Writeln('<br><b> FormInteger, FormFloat, FormString have default value variable</b>');
    Writeln('<ul style="color: red">');
      Writeln('<li>function GetValue(VarName: string; var VarValue: string): boolean;</li>');
      Writeln('<li>function FormInteger(VarName: string; var RetValue: integer; DefValue: integer): boolean;</li>');
      Writeln('<li>function FormFloat(VarName: string; var RetValue: double; DefValue: double): boolean;</li>');
      Writeln('<li>function FormString(VarName: string; var RetValue: string; DefValue: string): boolean;</li>');
    Writeln('</ul>');

    Writeln('<br><b>These functions return predefined header</b>');
    Writeln('<ul style="color: red">');
      Writeln('<li>procedure ReturnHeaderExpire(ContentType: string);</li>');
      Writeln('<li>procedure ReturnHeader(ContentType: string; Expire: TDateTime);</li>');
      Writeln('procedure ReturnHeader(ContentType: string; Expire: TDateTime);</li>');
        Writeln('<br>if you put 0 as second parameter then page will never expire.');
        Writeln('If you want page to expire immediately after loaded then');
        Writeln('put some old date (for example 2 is good old date)');
      Writeln('<li>procedure Redirect(URL: string);</li>');
    Writeln('</ul>');


    Writeln('<br><b>This function returns Environment variables to browser for debugging</b>');
    Writeln('<ul style="color: red">');
      Writeln('<li>procedure ReturnVariables;</li>');
    Writeln('</ul>');

    Writeln('<br><b>XML Functions - every function returns &lt;node&gt;value&lt;/node&gt;LINE_BREAK</b>');
    Writeln('<ul style="color: red">');
      Writeln('<li>function  WriteOneNodeS(NodeName, NodeValue: string): string;</li>');
      Writeln('<li>function  WriteOneNode(NodeName, NodeValue: string): string;</li>');
    Writeln('</ul>');

    Writeln('<br><b>These functions return Month and DayOfWeek in string format - Borland routines</b>');
    Writeln('<ul style="color: red">');
      Writeln('<li>function  DayOfWeekStr(DateTime: TDateTime): string;</li>');
      Writeln('<li>function  MonthStr(DateTime: TDateTime): string;</li>');
    Writeln('</ul>');

    Writeln('<br><b>These are cookie functions</b>');
    Writeln('<ul style="color: red">');
      Writeln('<li>procedure ResetCookieString;</li>');
      Writeln('<li>procedure AddCookie(CookieName: string; CookieValue: string;Expire: TDateTime; PathName: string; DomainName: string; Secure: boolean);</li>');
      Writeln('<li>function GetCookie(CookieName: string; var CookieValue: string): boolean;</li>');
    Writeln('</ul>');

    Writeln('<br><b>This function will convert Local time to GMT time</b>');
    Writeln('<ul style="color: red">');
      Writeln('<li>function LocalToGMT(InTime: TDateTime): TDateTime;</li>');
    Writeln('</ul>');

    Writeln('<br><b>Generic functions</b>');
    Writeln('<ul style="color: red">');
      Writeln('<li>    function  HTTPDecode(const AStr: String): String; // Borland routine</li>');
      Writeln('<li>    function  HTTPEncode(const AStr: String): String; // Borland routine</li>');
      Writeln('<li>    function  XMLEncode(var InStr: string): String;</li>');
      Writeln('<li>    function  GetEnvVariable(Name : String) : String; // For extra environment variable</li>');
    Writeln('</ul>');

  Writeln('</b>');

  Writeln('<br>To extract value from query request (POST or GET method it does not matter)');
  Writeln('<br>just declare variable (interger, double or string) and call one of');
  Writeln('<br>following functions: FormInteger, FormFloat, FormString');
  Writeln('<br>Each of these functions will extract value from request string');
  Writeln('<br>and then it will try to convert this value to float or integer if requested.');
  Writeln('<br>If not found, function will return default value');
  Writeln('<br>Example: I want to extract THEBEST value from request string.');
  Writeln('<br>I expect that THEBEST value is integer. If THEBEST is not an integer or');
  Writeln('<br>if THEBEST is not found then I want to set default value. Default value is -1.');
  Writeln('<br>');

  Writeln('<b>');
  Writeln('<br>procedure blabla;');
  Writeln('<br>var TheBest: integer;');
  Writeln('<br>begin');
  Writeln('<br>&nbsp;&nbsp;CGI.FormInteger(''THEBEST'', TheBest, -1));');
  Writeln('<br>&nbsp;&nbsp;// after this call, variable TheBest have value from request string');
  Writeln('<br>end;');
  Writeln('</b>');


  Writeln('</BODY>');
end;


procedure GetInputForm;
var myFile: TextFile;
    myChar: Char;
const myFileName: String = '.\Example.html';
begin
  CGI.ReturnHeader('text/html', 2);
  Assign(myFile, myFileName);
  try
    Reset(myFile);
    while not(Eof(myFile)) do begin
      read(myFile, myChar);
      write(myChar);
    end;
  finally
    try
      Close(myFile);
    except
      on E: Exception do begin
        writeln('CGI tried to open file: ', myFileName);
        writeln('<br>');
        writeln(E.Message);
        beep;
      end;
    end;
  end;
end;

procedure ExtractInputForm;
var FirstName, LastName: string;
    Age: double;
begin
  CGI.ReturnHeader('text/html', 2);
  CGI.FormString('firstname', FirstName, 'DINX');
  CGI.FormString('lastname', LastName, 'AS');
  CGI.FormFloat('age', Age, 0.01);
  Writeln('<HTML>');
  Writeln('<BODY>');
  Writeln('You entered values: ');
  Writeln('<br>');
  Writeln('First Name: ' + FirstName);
  Writeln('<br>');
  Writeln('Last Name: ', LastName);
  Writeln('<br>');
  Writeln('Depending on system settings use . or , as decimal separator');
  Writeln('<br>');
  Writeln('Age: ', FloatToStr(Age));
  Writeln('</BODY>');
  Writeln('</HTML>');
end;


begin
  // Begining of main program - create neccessery objects
  CGI := TCGI.Create;

  with CGI do begin
    if (PATH_INFO='/Exec') then Exec()
    else if (PATH_INFO='/GetInputForm') then GetInputForm()
    else if (PATH_INFO='/ExtractInputForm') then ExtractInputForm()
    else ReturnVariables;
  end;

  // release memory
  CGI.Destroy;
end.



